import 'package:flutter/material.dart';

class LifecycleWatcher extends StatefulWidget {
  final Function(BuildContext, AppLifecycleState?) builder;

  const LifecycleWatcher({required this.builder});

  @override
  State<LifecycleWatcher> createState() => _LifecycleWatcherState();
}

class _LifecycleWatcherState extends State<LifecycleWatcher>
    with WidgetsBindingObserver {
  AppLifecycleState? lastState;

  @override
  void initState() {
    super.initState();
    WidgetsBinding.instance.addObserver(this);
  }

  @override
  void dispose() {
    WidgetsBinding.instance.removeObserver(this);
    super.dispose();
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState appState) {
    setState(() {
      lastState = appState;
    });
  }

  @override
  Widget build(BuildContext context) => widget.builder(context, lastState);
}
